(ns wanijo.instance.view.bulk-link-selection
  (:require [hiccup.form :as hform]
            [hiccup.core :refer [h]]
            [wanijo.infrastructure.view :as view]
            [wanijo.infrastructure.routing :refer [path]]
            [formulare.core :as form]
            [ring.util.anti-forgery :refer [anti-forgery-field]]))

(defn bulk-link-selection [instance forms req]
  (clojure.pprint/pprint forms)
  (view/layout
   :request req
   :content
   [[:h1
     [:small "Link " (-> instance :schema :name h) " "]
     (h (:name instance))
     [:small " with..."]]
    (hform/form-to
     {:class "no-grid"}
     [:post (path :instance-bulk-link-create instance)]
     (anti-forgery-field)
     (for [{:keys [schema instances]} forms]
       (list
        [:h2 "Schema " (h (:name schema))]
        [:label
         "Link name "
         [:input {:name (str "name[" (:uuid schema) "]")}]]
        [:table
         [:thead
          [:tr
           [:th "Selection"]
           [:th "Name"]]]
         [:tbody
          (for [{:keys [name uuid]} instances]
            [:tr
             [:td {:style "text-align: center;"}
              [:input {:type "checkbox"
                       :name (str "instances[" (:uuid schema) "]")
                       :value uuid}]]
             [:td (h name)]])]]))
     (hform/submit-button "Link!"))]))
